#include "hts221.h"
//--------------------------------------------
//    
volatile int8_t avg_cnt;
volatile int8_t avg_cnt_temp;
//--------------------------------------------
extern I2C_HandleTypeDef hi2c1;
extern UART_HandleTypeDef huart2;
uint8_t buf2[14]={0};
char str1[100]={0};
//--------------------------------------------
void Error(void)
{
	LD2_OFF;
}
//--------------------------------------------
int32_t MovingAverage(int32_t dt)
{
//   
	static int32_t buf_avg[8]={0};
//   
	static int64_t tmp64;
	int32_t dt_ret;
	if(avg_cnt<8)
	{
		buf_avg[avg_cnt]=dt;
		if(avg_cnt==7)
		{
			tmp64=buf_avg[7]+buf_avg[6]+buf_avg[5]+buf_avg[4]+\
							 buf_avg[3]+buf_avg[2]+buf_avg[1]+buf_avg[0];
			dt_ret=tmp64/8;
		}
		avg_cnt++;
	}
	else
	{
		//     ( ) 
		tmp64-=buf_avg[0];
		//   1 
		memcpy((void*)buf_avg,(void*)(buf_avg+1),sizeof(int32_t)*7);
		// 7   
		buf_avg[7]=dt;
		//  
		tmp64+=dt;
		//  
		dt_ret=tmp64/8;
	}
	return dt_ret;
}
//--------------------------------------------
int32_t MovingAverageTemp(int32_t dt)
{
//   
	static int32_t buf_avg[8]={0};
//   
	static int64_t tmp64;
	int32_t dt_ret;
	if(avg_cnt_temp<8)
	{
		buf_avg[avg_cnt_temp]=dt;
		if(avg_cnt_temp==7)
		{
			tmp64=buf_avg[7]+buf_avg[6]+buf_avg[5]+buf_avg[4]+\
							 buf_avg[3]+buf_avg[2]+buf_avg[1]+buf_avg[0];
			dt_ret=tmp64/8;
		}
		avg_cnt_temp++;
	}
	else
	{
		//     ( ) 
		tmp64-=buf_avg[0];
		//   1 
		memcpy((void*)buf_avg,(void*)(buf_avg+1),sizeof(int32_t)*7);
		// 7   
		buf_avg[7]=dt;
		//  
		tmp64+=dt;
		//  
		dt_ret=tmp64/8;
	}
	return dt_ret;
}
//--------------------------------------------
static uint8_t I2Cx_ReadData(uint16_t Addr, uint8_t Reg)
{
	HAL_StatusTypeDef status = HAL_OK;
	uint8_t value = 0;
	status = HAL_I2C_Mem_Read(&hi2c1, Addr, Reg, I2C_MEMADD_SIZE_8BIT, &value, 1, 0x10000);
	if(status != HAL_OK) Error();
	return value;
}
//--------------------------------------------
static void I2Cx_WriteData(uint16_t Addr, uint8_t Reg, uint8_t Value)
{
	HAL_StatusTypeDef status = HAL_OK;
	status = HAL_I2C_Mem_Write(&hi2c1, Addr, (uint16_t)Reg, I2C_MEMADD_SIZE_8BIT, &Value, 1, 0x10000);
	if(status != HAL_OK) Error();
}
//--------------------------------------------
uint8_t Humidity_IO_Read(uint16_t DeviceAddr, uint8_t RegisterAddr)
{
	return I2Cx_ReadData(DeviceAddr, RegisterAddr);
}
//--------------------------------------------
void Humidity_IO_Write(uint16_t DeviceAddr, uint8_t RegisterAddr, uint8_t Value)
{
	I2Cx_WriteData(DeviceAddr, RegisterAddr, Value);
}
//--------------------------------------------
void Humidity_Get_Temp(float* pData)
{
	uint8_t btnstat;
	int16_t T0_degC,T1_degC;
	int16_t T0_out, T1_out, T_out, T0_degC_x8_u16, T1_degC_x8_u16;
	uint8_t buffer[4],tmp;
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T0_DEGC_X8);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T1_DEGC_X8);
	tmp=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T0_T1_DEGC_H2);
	T0_degC_x8_u16 = (((uint16_t)(tmp & 0x03)) << 8) | ((uint16_t)buffer[0]);
	T1_degC_x8_u16 = (((uint16_t)(tmp & 0x0C)) << 6) | ((uint16_t)buffer[1]);
	T0_degC = T0_degC_x8_u16 >> 3;
	T1_degC = T1_degC_x8_u16 >> 3;
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T0_OUT_L);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T0_OUT_H);
	buffer[2]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T1_OUT_L);
	buffer[3]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_T1_OUT_H);
	T0_out = (((uint16_t)buffer[1])<<8)|((uint16_t)buffer[0]);
	T1_out = (((uint16_t)buffer[3])<<8)|((uint16_t)buffer[2]);
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_TEMP_OUT_L_REG);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_TEMP_OUT_H_REG);
	T_out = (((uint16_t)buffer[1])<<8)|((uint16_t)buffer[0]);	
	T_out = (((uint16_t)buffer[1]<<8)+(uint16_t)buffer[0]);
	btnstat=HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_13);
	//   ,
	//    
	if(btnstat!=0)	T_out =  MovingAverageTemp(T_out);
	*pData = (float)(T_out - T0_out) * (float)(T1_degC - T0_degC) /\
		(float)(T1_out - T0_out) + T0_degC;
}
//--------------------------------------------
void Humidity_Get_Hum(float* pData)
{
	uint8_t btnstat;
	uint8_t buffer[2];
	int16_t H0_T0_out, H1_T0_out, H_T_out;
	int16_t H0_rh, H1_rh;
	float tmp_f;
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_H0_RH_X2);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_H1_RH_X2);
	H0_rh = buffer[0] >> 1;
	H1_rh = buffer[1] >> 1;
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_H0_T0_OUT_L);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_H0_T0_OUT_H);
	H0_T0_out = (((uint16_t)buffer[1])<<8)|((uint16_t)buffer[0]);	
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_H1_T0_OUT_L);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_H1_T0_OUT_H);
	H1_T0_out = (((uint16_t)buffer[1])<<8)|((uint16_t)buffer[0]);	
	buffer[0]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_HR_OUT_L_REG);
	buffer[1]=Humidity_IO_Read(HTS221_ADDRESS,HTS221_HR_OUT_H_REG);
	H_T_out = (((uint16_t)buffer[1])<<8)|((uint16_t)buffer[0]);	
	btnstat=HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_13);
	//   ,
	//    
	if(btnstat!=0)	H_T_out =  MovingAverage(H_T_out);
	tmp_f = (float)(H_T_out - H0_T0_out) * (float)(H1_rh - H0_rh) /\
	(float)(H1_T0_out - H0_T0_out) + H0_rh;
	*pData = (tmp_f>100.0f)?100.0f
		:(tmp_f<0.0f)?0.0f
		:tmp_f;
}
//--------------------------------------------
uint8_t Humidity_ReadID(void)
{
	uint8_t ctrl = 0x00;
	ctrl = Humidity_IO_Read(HTS221_ADDRESS,HTS221_WHO_AM_I_REG);
	return ctrl;
}
//--------------------------------------------
void Humidity_Read(void)
{
	float temper,hum;
	Humidity_Get_Temp(&temper);
	Humidity_Get_Hum(&hum);
//	sprintf(str1,"TEMP:%06f; HUMIDITY:%06f\r\n", temper, hum);
//	HAL_UART_Transmit(&huart2, (uint8_t*)str1,strlen(str1),0x1000);
	uint8_t *t=(uint8_t*)&temper;
	uint8_t *h=(uint8_t*)&hum;
	buf2[0]=0x11;
	buf2[1]=0x55;
	buf2[2]=(uint8_t)(*(uint32_t*)t);
	buf2[3]=(uint8_t)((*(uint32_t*)t)>>8);
	buf2[4]=(uint8_t)((*(uint32_t*)t)>>16);
	buf2[5]=(uint8_t)((*(uint32_t*)t)>>24);
	buf2[6]=(uint8_t)(*(uint32_t*)h);
	buf2[7]=(uint8_t)((*(uint32_t*)h)>>8);
	buf2[8]=(uint8_t)((*(uint32_t*)h)>>16);
	buf2[9]=(uint8_t)((*(uint32_t*)h)>>24);
	HAL_UART_Transmit(&huart2,buf2,10,0x1000);
//	HAL_Delay(200);
}

//--------------------------------------------
void HumidityInit(uint16_t InitStruct)
{
	uint8_t value = 0;
//   (PD = 0)
	value = Humidity_IO_Read(HTS221_ADDRESS,HTS221_CTRL_REG1);
	value&=~HTS221_PD_MASK;
	value|=HTS221_PD_POWERDOWN_MODE;
	Humidity_IO_Write(HTS221_ADDRESS,HTS221_CTRL_REG1,value);
//Enable BDU
	value = Humidity_IO_Read(HTS221_ADDRESS,HTS221_CTRL_REG1);
	value&=~HTS221_BDU_MASK;
	value|=HTS221_BDU_ENABLE;
	Humidity_IO_Write(HTS221_ADDRESS,HTS221_CTRL_REG1,value);
// Data Rate 12.5 
	value = Humidity_IO_Read(HTS221_ADDRESS,HTS221_CTRL_REG1);
	value&=~HTS221_ODR_MASK;
	value|=HTS221_ODR_12_5HZ;
	Humidity_IO_Write(HTS221_ADDRESS,HTS221_CTRL_REG1,value);
//   (PD = 1)
	value = Humidity_IO_Read(HTS221_ADDRESS,HTS221_CTRL_REG1);
	value&=~HTS221_PD_MASK;
	value|=HTS221_PD_ACTIVE_MODE;
	Humidity_IO_Write(HTS221_ADDRESS,HTS221_CTRL_REG1,value);
}
//--------------------------------------------
void Humidity_Ini(void)
{
	uint16_t ctrl = 0x0000;
	//    
	avg_cnt=0;
	avg_cnt_temp=0;
	HAL_Delay(1000);
	if(Humidity_ReadID()==HTS221_WHO_AM_I_VAL) LD2_ON;
	else Error();
	LD2_OFF;
	HumidityInit(ctrl);
	LD2_ON;
}
